// *************************************************************************
//
// Copyright (C) 2004-2006 Bruno PAGES  All rights reserved.
//
// This file is part of the BOUML Uml Toolkit.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
// e-mail : bouml@free.fr
// home   : http://bouml.free.fr
//
// *************************************************************************

#ifndef TOOLDIALOG_H
#define TOOLDIALOG_H

#include <qdialog.h>

#include "StringTable.h"

class ToolTable;

class ToolDialog : public QDialog {
  Q_OBJECT
    
  protected:
    ToolTable * table;
    
  public:
    ToolDialog(const QPoint & p);
  
  protected slots:
    virtual void accept();
};

class ToolTable : public StringTable {
  Q_OBJECT
    
  public:
    ToolTable(QWidget * parent);
  
    virtual void init_row(int r);

    void update();
  
  protected slots:
    virtual void button_pressed(int row, int col, int button, const QPoint & mousePos);
};

#endif
